#include <io.h>
#include <system.h>
#include <stdio.h>

#define BASE 0x00080800

//Color Map - 16
#define WHITE 0x0000
#define YELLOW 0x1000
#define FUCHSIA 0x2000
#define RED 0x3000
#define SILVER 0x4000
#define GRAY 0x5000
#define OLIVE 0x6000
#define PURPLE 0x7000
#define MAROON 0x8000
#define AQUA 0x9000
#define LIME 0xA000
#define TEAL 0xB000
#define GREEN 0xC000
#define BLUE 0xD000
#define NAVY 0XE000
#define BLACK 0XF000

// Score points
#define MISS -8
#define PERFECT 4
#define GOOD 2
#define BAD -10
#define FLASHTIME 60
 
// function prototypes
unsigned int keypress();
void kill(int killed);
void pressed(int button);
void ChangeScore(int change);

// key information
unsigned int data = 0;

unsigned int key0_old = 0;
unsigned int key0_new = 0;
unsigned int key0 = 0;

unsigned int key1_old = 0;
unsigned int key1_new = 0;
unsigned int key1 = 0;

unsigned int key2_old = 0;
unsigned int key2_new = 0;
unsigned int key2 = 0;

unsigned int key3_old = 0;
unsigned int key3_new = 0;
unsigned int key3 = 0;

// note information

int NumButtons = 0;               // number of buttons on screen

/**********************
 *    Novice Mode     *
 *********************/
/*
int NumNotes = 28;                // number of notes
unsigned int NotesLane[] = { 0, 1, 2, 3,
                             0, 1, 2, 3, 
                             0, 1, 2, 3,
                             3, 2, 1, 0,
                             0, 1, 2, 3, 
                             3, 2, 1, 0,
                             0, 1, 2, 3
                           } ;

unsigned int NotesTime[] = { 100, 200, 300, 400,
                             700, 700, 700, 700,
                             1000, 1000, 1050, 1050,
                             1300, 1350, 1400, 1450,
                             1700, 1800, 1800, 1850,
                             2100, 2200, 2300, 2300,
                             2600, 2600, 2600, 2600
                           } ;
*/


/**********************
 *  Intermediate Mode *
 *********************/

int NumNotes = 64; 
unsigned int NotesLane[] = { 0, 1, 2, 3,
                             0, 1, 2, 3, 
                             0, 1, 2, 3,
                             3, 2, 1, 0,
                             0, 1, 2, 3, 
                             3, 2, 1, 0,
                             0, 1, 2, 3,
                             2, 1, 2, 3,
                             3, 0, 0, 1, 
                             1, 3, 2, 0, 
                             1, 2, 0, 3, 
                             3, 0, 2, 1,
                             1, 0, 0, 3, 
                             2, 3, 0, 2,
                             0, 2, 1, 2,
                             3, 1, 0, 3
                           } ;

unsigned int NotesTime[] = { 100, 100, 200, 200,
                             400, 450, 450, 450,
                             550, 550, 650, 700,
                             850, 950, 1000, 1000,
                             1150, 1150, 1200, 1250,
                             1400, 1400, 1400, 1500,
                             1700, 1750, 1750, 1800,
                             2000, 2150, 2150, 2150,
                             2300, 2350, 2400, 2400,
                             2700, 2750, 2850, 2900,
                             3150, 3200, 3250, 3250,
                             3300, 3450, 3500, 3550,
                             3700, 3750, 3800, 3800,
                             3900, 3950, 3950, 4000,
                             4200, 4200, 4250, 4250,
                             4400, 4450, 4500, 4500
                           } ;

                           
/**********************
 *    Expert Mode     *
 *********************/
/*
int NumNotes = 132;                // number of notes
unsigned int NotesLane[] = { 1, 2, 3, 0,
                             3, 1, 2, 0,
                             2, 3, 1, 0,
                             1, 2, 3, 0,
                             3, 0, 2, 3, 
                             1, 2, 3, 0,
                             1, 2, 3, 0,
                             1, 2, 0, 3,
                             1, 3, 2, 0,
                             1, 3, 2, 0,
                             2, 0, 0, 3,
                             2, 1, 3, 0,  
                             1, 3, 2, 0,
                             1, 2, 2, 0,
                             1, 2, 3, 0,
                             0, 3, 2, 3, 
                             0, 2, 1, 2,
                             2, 1, 0, 3,
                             2, 3, 0, 1,
                             3, 0, 1, 2,
                             2, 0, 3, 1, 
                             0, 2, 3, 0,
                             0, 3, 2, 1,
                             1, 2, 3, 0,
                             3, 0, 2, 3,
                             2, 1, 3, 2,
                             0, 3, 0, 1,
                             0, 2, 1, 3,
                             1, 0, 3, 2,
                             2, 3, 1, 0, 
                             1, 3, 2, 1, 
                             0, 1, 2, 3,
                             1, 1, 0, 2
                             } ;
    
unsigned int NotesTime[] = { 100,  100,  150,  200,
                             300,  350,  450,  500,
                             700,  750,  800,  850,
                             900,  900,  950,  950,
                             1050, 1050, 1100, 1150,
                             1300, 1300, 1400, 1400,
                             1600, 1600, 1650, 1700,
                             1800, 1800, 1850, 1900,
                             2000, 2100, 2150, 2150,
                             2300, 2300, 2400, 2400,
                             2500, 2550, 2600, 2600,
                             2750, 2800, 2800, 2950, 
                             3100, 3100, 3150, 3150,
                             3300, 3300, 3350, 3400, 
                             3600, 3650, 3700, 3750,
                             3900, 3900, 3950, 4000,
                             4200, 4200, 4250, 4250,
                             4350, 4400, 4400, 4450, 
                             4550, 4550, 4600, 4650,
                             4750, 4800, 4850, 4900,
                             5050, 5150, 5150, 5200,
                             5300, 5350, 5350, 5400,
                             5450, 5500, 5500, 5550,
                             5650, 5700, 5700, 5750,
                             5850, 5850, 5900, 5950,
                             6050, 6050, 6100, 6150,
                             6250, 6250, 6350, 6400,
                             6450, 6500, 6550, 6550,
                             6600, 6750, 6750, 6800,
                             6900, 7000, 7050, 7050,
                             7150, 7150, 7250, 7300,
                             7450, 7500, 7500, 7550,
                             7600, 7700, 7700, 7700
                             } ;
*/

             
int i, j;                      // temp variables
unsigned int packet[10];       // packets used to send information
 
// button information
unsigned int ColorCode[] = {BLUE, LIME, RED, YELLOW};
unsigned int Color[]     = {0, 0, 0, 0, 0, 0, 0, 0};
unsigned int Existence[] = {0, 0, 0, 0, 0, 0, 0, 0};
unsigned int HPos[]      = {0, 0, 0, 0, 0, 0, 0, 0};
unsigned int VPos[]      = {0, 0, 0, 0, 0, 0, 0, 0};

// game information
unsigned int VMax = 429;
unsigned int Time = 0;            // current time
int CurrentNote;                  // current note

// score
int score = 50;
int real_score = 50;
int perfects = 0;
int max_perfects = 0;
int how_good = 0;
int position = 0;

int time0 = 0;
int time1 = 0;
int time2 = 0;
int time3 = 0;

int b0 = 0;
int b1 = 0;
int b2 = 0;
int b3 = 0;

int gameStatus = 0;
int started = 0;

int main()
{
  // game start
  while (1)
  {
    printf ("Welcome to Button Hero! Press any key to begin game!\n\n");
    gameStatus = 0;
    
    IOWR_16DIRECT(BASE, 18, 0);
    
    // update score
    ChangeScore(0);
    
    // pause until key pressed
    do
    {
      keypress();
    } while (!key0 && !key1 && !key2 && !key3);

    
    // update score
    ChangeScore(0);
    gameStatus = 2;
    
    printf ("Good luck!\n\n");

    // while there are still notes left to play, or there are buttons to be pressed
    while (CurrentNote < NumNotes || NumButtons > 0)
    {
      for (j=0; j<8; j++)
      {
        // button exists
        if (Existence[j] == 0x0800)
        {
          VPos[j] = VPos[j]+1;           // move button
           
          // kill button
          if (VPos[j] == VMax)
          {
            //printf ("Missed!\t");
            
            // for score keeping
            perfects = 0;
            how_good = 0;
            position = HPos[j] >> 9;
            ChangeScore(MISS);
            kill(j);
            j--;
          }
        }
      }
        
      // send information to hardware
      for (j=0; j<8; j++)
      {
        packet[j] = Color[j] | Existence[j] | HPos[j] | VPos[j];
        IOWR_16DIRECT(BASE, 2*j, packet[j]);
      }
      
      if (time0 <= 0)
        b0 = b0 & 3;
      else
        b0 = b0 | 4;
      if (time1 <= 0)
        b1 = b1 & 3;
      else
        b1 = b1 | 4;
      if (time2 <= 0)
        b2 = b2 & 3;
      else
        b2 = b2 | 4;
      if (time3 <= 0)
        b3 = b3 & 3;
      else
        b3 = b3 | 4;
      
      packet[9] = (gameStatus << 12) | (b3 << 9) | (b2 << 6) | (b1 << 3) | b0;
      if (Time > NotesTime[0]) //buffer time
        IOWR_16DIRECT(BASE, 18, packet[9]);
      
          

      // a key was pressed
      keypress();

      if (key0)
        pressed(3<<9);
      if (key1)
        pressed(2<<9);
      if (key2)
        pressed(1<<9);
      if (key3)
        pressed(0<<9);


  
      // look for more notes to add to queue
      while (Time >= NotesTime[CurrentNote] && NumButtons < 8 && CurrentNote < NumNotes)
      {
        // get next note
        Existence[NumButtons]=0x0800;
        HPos[NumButtons]=(NotesLane[CurrentNote])<<9;
        Color[NumButtons]=ColorCode[NotesLane[CurrentNote]];
        VPos[NumButtons]=0;
          
        NumButtons++;
        CurrentNote++;
      }

        for (i = 0 ; i < (2<<11) ; i++) ;
      Time++;
      time0--;
      time1--;
      time2--;
      time3--;
      
      // too many buttons on screen at once
      if(NumButtons>8)
      {
        printf ("Error! Button overload.");
        
        break;
      }
    }

    printf("\n\nEnd of game. Press any key to restart.\n\n");
    
    CurrentNote = 0;
    NumButtons = 0;
    Time = 0;
    real_score = 50;
    perfects = 0;
    max_perfects = 0;
    
    time0 = 0;
    time1 = 0;
    time2 = 0;
    time3 = 0;
    
    b0 = 0;
    b1 = 0;
    b2 = 0;
    b3 = 0;
    
    for (i = 0; i < 8; i++)
    {
      Color[i] = 0;
      Existence[i] = 0;
      HPos[i] = 0;
      VPos[i] = 0;
    }
    
    // send information to hardware (to clear remaining tiles)
    for (j=0; j<8; j++)
    {
      packet[j] = Color[j] | Existence[j] | HPos[j] | VPos[j];
      IOWR_16DIRECT(BASE, 2*j, packet[j]);
    }
    
    gameStatus = 3;
    packet[9] = gameStatus << 12;
    IOWR_16DIRECT(BASE, 18, packet[9]);
      
    // pause until key pressed
    do
    {
      keypress();
    } while (!key0 && !key1 && !key2 && !key3);

  }
 
  printf("Goodbye!\n");
 
  return 0;
 
}


unsigned int keypress()
{
  data = IORD_16DIRECT(BASE, 20);
 
  // if respective key is pressed
  key0_new = data & 1;
  key1_new = data & 2;
  key2_new = data & 4;
  key3_new = data & 8;
 
  // if it is on action of being pressed down
  if (key0_new == 0 && key0_old != 0)
    key0 = 1;
  else
    key0 = 0;
    
  if (key1_new == 0 && key1_old != 0)
    key1 = 1;
  else
    key1 = 0;
 
  if (key2_new == 0 && key2_old != 0)
    key2 = 1;
  else
    key2 = 0;
 
  if (key3_new == 0 && key3_old != 0)
    key3 = 1;
  else
    key3 = 0;
 
  // update information
  key0_old = key0_new;
  key1_old = key1_new;
  key2_old = key2_new;
  key3_old = key3_new;
 
  return data;
}

void kill(int killed)
{
  NumButtons--;
 
  int i;
  for(i = killed; i < NumButtons; i++)
  {
    Existence[i] = Existence[i+1];
    Color[i] = Color[i+1];
    HPos[i] = HPos[i+1];
    VPos[i] = VPos[i+1];
  }
 
  Existence[NumButtons] = 0;
  Color[NumButtons] = 0;
  HPos[NumButtons] = 0;
  VPos[NumButtons] = 0;
}


void pressed(int button)
{
  int button_exist = 0;
 
  for (j = 0; j < 8; j++)
  {
    if (Existence[j] == 0x0800 && HPos[j] == (button))    // button exists in lane
    {
      if ((VPos[j] - 370) < 10 || (VPos[j] - 370) > -10)          // perfect!
      {
        //printf("PERFECT!!!\t");
        how_good = 1;
        position = button >> 9;
        ChangeScore(PERFECT);
        perfects++;
        kill(j);
        button_exist = 1;
      }
      
      else if ((VPos[j] - 370) < 15 || (VPos[j] - 370) > -15)     // good!
      {
        //printf("Good!!\t");
        perfects = 0;
        how_good = 2;
        position = button >> 9;
        ChangeScore(GOOD);
        kill(j);
        button_exist = 1;
      }
      else if ((VPos[j] - 370) < 50 || (VPos[j] - 370) > -50)     // bad!
      {
        //printf("Good!!\t");
        perfects = 0;
        how_good = 3;
        position = button >> 9;
        ChangeScore(BAD);
        kill(j);
        button_exist = 1;
      }
    }
  }
 
  // Not perfect or good
  if (button_exist == 0)
  {
    how_good = 3;
    perfects = 0;
    position = button >> 9;
    //printf("Bad!\t");
    ChangeScore(BAD);
  }
}

void ChangeScore(int change)
{
  real_score += change;
 
  if (real_score > 120)
    real_score = 100;
    
  else if (real_score < -20)
    real_score = -10;
    
  if (real_score > 100)
    score = 100;
  else if (real_score < 0)
    score = 0;
  else
    score = real_score;
    
  if (position == 3)
  {
    b0 = how_good;
    time0 = FLASHTIME;
  }
  if (position == 2)
  {
    b1 = how_good;
    time1 = FLASHTIME;
  }
  if (position == 1)
  {
    b2 = how_good;
    time2 = FLASHTIME;
  }
  if (position == 0)
  {
    b3 = how_good;
    time3 = FLASHTIME;
  }
  
  perfects = perfects & 31;
  if (perfects > max_perfects)
    max_perfects = perfects;
  packet[8] = (score << 9) | (max_perfects << 4) | 0;

  IOWR_16DIRECT(BASE, 16, packet[8]);
 
  //printf ("Score = %d, Perfects = %d, Packet16 = %X\n", score, perfects, packet[9]);
  

}
