--Legal Notice: (C)2006 Altera Corporation. All rights reserved.  Your
--use of Altera Corporation's design tools, logic functions and other
--software and tools, and its AMPP partner logic functions, and any
--output files any of the foregoing (including device programming or
--simulation files), and any associated documentation or information are
--expressly subject to the terms and conditions of the Altera Program
--License Subscription Agreement or other applicable license agreement,
--including, without limitation, that your use is for the sole purpose
--of programming logic devices manufactured by Altera and sold by Altera
--or its authorized distributors.  Please refer to the applicable
--agreement for further details.


-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.standard.all;

entity vgas is 
        port (
              -- inputs:
                 signal avs_s1_address : IN STD_LOGIC_VECTOR (4 DOWNTO 0);
                 signal avs_s1_chipselect : IN STD_LOGIC;
                 signal avs_s1_clk : IN STD_LOGIC;
                 signal avs_s1_read : IN STD_LOGIC;
                 signal avs_s1_reset_n : IN STD_LOGIC;
                 signal avs_s1_write : IN STD_LOGIC;
                 signal avs_s1_writedata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal key : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal reset : IN STD_LOGIC;

              -- outputs:
                 signal HEX0 : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal HEX1 : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal HEX2 : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal HEX3 : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal HEX4 : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal HEX5 : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal HEX6 : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal HEX7 : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                 signal VGA_B : OUT STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal VGA_BLANK : OUT STD_LOGIC;
                 signal VGA_CLK : OUT STD_LOGIC;
                 signal VGA_G : OUT STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal VGA_HS : OUT STD_LOGIC;
                 signal VGA_R : OUT STD_LOGIC_VECTOR (9 DOWNTO 0);
                 signal VGA_SYNC : OUT STD_LOGIC;
                 signal VGA_VS : OUT STD_LOGIC;
                 signal avs_s1_readdata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal ledgreen : OUT STD_LOGIC_VECTOR (8 DOWNTO 0);
                 signal ledred : OUT STD_LOGIC_VECTOR (17 DOWNTO 0)
              );
end entity vgas;


architecture europa of vgas is
component vga_raster is 
           port (
                 -- inputs:
                    signal avs_s1_address : IN STD_LOGIC_VECTOR (4 DOWNTO 0);
                    signal avs_s1_chipselect : IN STD_LOGIC;
                    signal avs_s1_clk : IN STD_LOGIC;
                    signal avs_s1_read : IN STD_LOGIC;
                    signal avs_s1_reset_n : IN STD_LOGIC;
                    signal avs_s1_write : IN STD_LOGIC;
                    signal avs_s1_writedata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal key : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal reset : IN STD_LOGIC;

                 -- outputs:
                    signal HEX0 : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal HEX1 : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal HEX2 : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal HEX3 : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal HEX4 : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal HEX5 : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal HEX6 : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal HEX7 : OUT STD_LOGIC_VECTOR (6 DOWNTO 0);
                    signal VGA_B : OUT STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal VGA_BLANK : OUT STD_LOGIC;
                    signal VGA_CLK : OUT STD_LOGIC;
                    signal VGA_G : OUT STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal VGA_HS : OUT STD_LOGIC;
                    signal VGA_R : OUT STD_LOGIC_VECTOR (9 DOWNTO 0);
                    signal VGA_SYNC : OUT STD_LOGIC;
                    signal VGA_VS : OUT STD_LOGIC;
                    signal avs_s1_readdata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal ledgreen : OUT STD_LOGIC_VECTOR (8 DOWNTO 0);
                    signal ledred : OUT STD_LOGIC_VECTOR (17 DOWNTO 0)
                 );
end component vga_raster;

                signal internal_HEX0 :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal internal_HEX1 :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal internal_HEX2 :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal internal_HEX3 :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal internal_HEX4 :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal internal_HEX5 :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal internal_HEX6 :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal internal_HEX7 :  STD_LOGIC_VECTOR (6 DOWNTO 0);
                signal internal_VGA_B :  STD_LOGIC_VECTOR (9 DOWNTO 0);
                signal internal_VGA_BLANK :  STD_LOGIC;
                signal internal_VGA_CLK :  STD_LOGIC;
                signal internal_VGA_G :  STD_LOGIC_VECTOR (9 DOWNTO 0);
                signal internal_VGA_HS :  STD_LOGIC;
                signal internal_VGA_R :  STD_LOGIC_VECTOR (9 DOWNTO 0);
                signal internal_VGA_SYNC :  STD_LOGIC;
                signal internal_VGA_VS :  STD_LOGIC;
                signal internal_avs_s1_readdata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal internal_ledgreen :  STD_LOGIC_VECTOR (8 DOWNTO 0);
                signal internal_ledred :  STD_LOGIC_VECTOR (17 DOWNTO 0);

begin

  --the_vga_raster, which is an e_instance
  the_vga_raster : vga_raster
    port map(
      HEX0 => internal_HEX0,
      HEX1 => internal_HEX1,
      HEX2 => internal_HEX2,
      HEX3 => internal_HEX3,
      HEX4 => internal_HEX4,
      HEX5 => internal_HEX5,
      HEX6 => internal_HEX6,
      HEX7 => internal_HEX7,
      VGA_B => internal_VGA_B,
      VGA_BLANK => internal_VGA_BLANK,
      VGA_CLK => internal_VGA_CLK,
      VGA_G => internal_VGA_G,
      VGA_HS => internal_VGA_HS,
      VGA_R => internal_VGA_R,
      VGA_SYNC => internal_VGA_SYNC,
      VGA_VS => internal_VGA_VS,
      avs_s1_readdata => internal_avs_s1_readdata,
      ledgreen => internal_ledgreen,
      ledred => internal_ledred,
      avs_s1_address => avs_s1_address,
      avs_s1_chipselect => avs_s1_chipselect,
      avs_s1_clk => avs_s1_clk,
      avs_s1_read => avs_s1_read,
      avs_s1_reset_n => avs_s1_reset_n,
      avs_s1_write => avs_s1_write,
      avs_s1_writedata => avs_s1_writedata,
      clk => clk,
      key => key,
      reset => reset
    );


  --vhdl renameroo for output signals
  HEX0 <= internal_HEX0;
  --vhdl renameroo for output signals
  HEX1 <= internal_HEX1;
  --vhdl renameroo for output signals
  HEX2 <= internal_HEX2;
  --vhdl renameroo for output signals
  HEX3 <= internal_HEX3;
  --vhdl renameroo for output signals
  HEX4 <= internal_HEX4;
  --vhdl renameroo for output signals
  HEX5 <= internal_HEX5;
  --vhdl renameroo for output signals
  HEX6 <= internal_HEX6;
  --vhdl renameroo for output signals
  HEX7 <= internal_HEX7;
  --vhdl renameroo for output signals
  VGA_B <= internal_VGA_B;
  --vhdl renameroo for output signals
  VGA_BLANK <= internal_VGA_BLANK;
  --vhdl renameroo for output signals
  VGA_CLK <= internal_VGA_CLK;
  --vhdl renameroo for output signals
  VGA_G <= internal_VGA_G;
  --vhdl renameroo for output signals
  VGA_HS <= internal_VGA_HS;
  --vhdl renameroo for output signals
  VGA_R <= internal_VGA_R;
  --vhdl renameroo for output signals
  VGA_SYNC <= internal_VGA_SYNC;
  --vhdl renameroo for output signals
  VGA_VS <= internal_VGA_VS;
  --vhdl renameroo for output signals
  avs_s1_readdata <= internal_avs_s1_readdata;
  --vhdl renameroo for output signals
  ledgreen <= internal_ledgreen;
  --vhdl renameroo for output signals
  ledred <= internal_ledred;

end europa;

